/************
 *
 *	sockipc.h
 *
 ************
*
*
*  $Id: sockipc.h,v 1.1.1.1 2006/01/02 05:25:48 greg Exp $
*
*/

#ifndef _sockipc_h_
#define _sockipc_h_

//#ifdef WINDOWS
#include <windows.h>
#include <winsock.h>

//#else  /* Unix */
//#include <sys/socket.h>
//#include <netinet/in.h>
//#include <arpa/inet.h>
//#include <netdb.h>

//#endif

#include <sys/types.h>
#include <memory.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>

#define TC_PORT       "6543"
#define DB_PORT       "7001"
#define LOCALHOST     "localhost"
#define TC_MESG_LEN   1024

#ifdef WINDOWS
#define SOCK_TRAFFIC  "C:\\ETC\\adotService"  /* endpoint for NT */
#else
#define SOCK_TRAFFIC  "/etc/adotService"       /* for endpoint function */
#endif

#ifndef SLE
#define SLE           sys_errlist[errno], errno
#endif

#ifndef FD_NUL
#define FD_NUL        ((fd_set *) 0)
#endif

extern int errno;
extern char *sys_errlist[];

// used by analyst.  host:service to send events
typedef struct
{
	char host[32];      // host for analyst to send events
	char service[8];    // port on host
} ANALACC ;

// used by real time displayer.
// low and high ID bytes of intersection controller
typedef struct
{
	int lo_id;      /* low id of Wapiti controller */
	int hi_id;      /* high id of Wapiti controller */
} DBACC ;

typedef struct
{
	int numberOfTc;
} TCVARBLE;

// message header for client to agent messages
typedef struct
{
	u_long mesg_id;  /* identifies the messages purpose */
	u_long sec_id;   /* secondary message identifier    */
	u_long reqid;    /* used for reliability            */
	long   ack;      /* acknowledge success of failure of operation */
	long   fd;       /* used by command processor to agent services */
} MSGHEADER;

// client to agent message
typedef struct
{
	u_long howManyByte;     /* how many bytes follow */
	MSGHEADER head;         /* the message header */
	TCVARBLE tcIds;         /* traffic controller ids */
} TCACCSEND;

// data for endpoint routine
typedef struct
{
	char program[32];  /* name of end point */
	u_long jurisId;    /* Jurisdiction ID of this end point */
	char hostname[64]; /* host name on which end point is running */
	char service[16];  /* port number of end point */
	char protocol[16]; /* protocol of service; tcp or udp */
	char hostfromsystem[64]; /* host name on which this code is running */
} ENDPNT;

// used to set/retrieve privileges for poller downloads
typedef struct
{
	int lo_id;
	int hi_id;
	int privilege;
} POLLPRIV;

//  function prototypes
int  connectUDP(char *, char *);
int  connectTCP(char *, char *);
int  passiveUDP(char *);
int  passiveTCP(char *, int);
int  connectsock(char *, char *, char *);
int  passivesock(char *, char *, int);

//int  endPoint(char*, char*, ENDPNT*);
//void errexit(char *);
//int  parseEndPoint(ENDPNT *, char *);

#endif

